Scriptname killmoonMagicCircleScript extends activemagiceffect  

import Math
import Utility

Int Property index  Auto

float Property Energy  Auto  
float Property Stamina  Auto 
float Property Damage  Auto   

; initial position vector
float Property xPos  Auto  
float Property yPos  Auto  
float Property zPos  Auto  

; fly vector
float Property dx Auto  
float Property dy  Auto  
float Property dz  Auto  

; private
float Property ang  Auto  
float Property xAng  Auto  
float Property yAng  Auto  
float Property zAng  Auto  
float Property x  Auto  
float Property x2  Auto  
float Property sin  Auto  
float Property cos  Auto  

ObjectReference Property Circle01  Auto
ObjectReference Property Circle02  Auto
ObjectReference Property Circle03  Auto

ObjectReference Property Dummy  Auto

ObjectReference Property Cast  Auto  
ObjectReference Property Target  Auto

Spell Property killMoon  Auto

Idle Property moonIdle  Auto  

killmoonQuestScript Property killmoonQuest  Auto  

Event OnEffectStart(Actor Target, Actor Caster)

	Actor PlayerActor =  Game.GetPlayer()

	if PlayerActor.IsWeaponDrawn() && !PlayerActor.IsFlying()

		PlayerActor.PlayIdle(moonIdle)

		Energy = PlayerActor.getav("Destruction") as float
		Energy = Energy  * 2

		Stamina = PlayerActor.getav("Stamina") as float
		Damage = Stamina - Energy

		if Damage > 0
			PlayerActor.damageAV("Stamina", Energy)
		else
			PlayerActor.damageAV("Stamina", Stamina)
			PlayerActor.damageAV("Health", Damage)
		endif		

		Utility.wait(0.5)

		killmoonQuest.indexCircle += 1
		killmoonQuest.indexCircle = killmoonQuest.indexCircle % 3

		if killmoonQuest.indexCircle == 1
			Dummy =  Circle01
		elseif killmoonQuest.indexCircle == 2
			Dummy =  Circle02
		else
			Dummy =  Circle03
		endif

		ang = PlayerActor.GetAngleZ()
		zang = ang

		if ang > 180
			ang = ang - 360
		endif

		x = ang*0.0174532925
		x2 = x*x
		sin = x*(1-(x2/6)*(1-(x2/20)*(1-(x2/42)*(1-(x2/72)*(1-x2/110)))))
		cos = 1-(0.5)*x2*(1-(x2/12)*(1-(x2/30)*(1-(x2/56)*(1-x2/90))))
		dx = 10*sin
		dy = 10*cos

		; vertical fly vector
		ang = PlayerActor.GetAngleX()
		xang = ang*cos ; uses settings from Horizontal Vector
		yang = -ang*sin

		x = -ang*0.0174532925

		x2 = x*x
		sin = x*(1-(x2/6)*(1-(x2/20)*(1-(x2/42)*(1-(x2/72)*(1-x2/110)))))
		cos = 1-(0.5)*x2*(1-(x2/12)*(1-(x2/30)*(1-(x2/56)*(1-x2/90))))
		dz = 10*sin

		; initial position vector (to add to player coords)
		xPos = 7*dx*cos
		yPos = 7*dy*cos
		zPos = 138+5*dz

		Dummy.Enable()
		Dummy.moveTo(PlayerActor, xPos , yPos , zPos )
		Dummy.setAngle(xAng, yAng, zAng)

		Cast.Enable()
		Cast.moveTo(PlayerActor, xPos , yPos , zPos )

		xPos = 7*dx*cos
		yPos = 7*dy*cos
		zPos = 8*dz

		Target.Enable()
		Target.moveTo(Dummy, xPos , yPos , zPos )
	
		Utility.wait(0.5)

		killMoon.Cast(Cast ,Target)

		Utility.wait(1)

		Cast.InterruptCast()
		Dummy.Disable()
		Cast.Disable()
		Target.Disable()

	endif

EndEvent

